#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class GomOFDeltaSampleStrat : Strategy
    {
        #region Variables
        // Wizard generated variables
        private int minAbsDelta = 500; // Default setting for MinAbsDelta
        private int target = 10; // Default setting for Target
        private int stop = 10; // Default setting for Stop
		
		private GomOrderFlowProValues gof;
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
            SetProfitTarget("", CalculationMode.Ticks, Target);
            SetStopLoss("", CalculationMode.Ticks, Stop, false);

            CalculateOnBarClose = true;
			
			// use the strategy builder to build the line with the correct parameters.
			gof=GomOrderFlowProValues(true, Gom.DeltaLib.DeltaCalcType.UpDownTick,Gom.OrderFlow.ImbalanceComparisonType.Ratio,Gom.OrderFlow.ImbalanceDirectionType.Diagonal, 3, Gom.OrderFlow.ImbalanceComparisonType.Ratio,Gom.OrderFlow.ImbalanceDirectionType.None, 3,false, -1,0, -1, 3, 1, 0, false,Gom.OrderFlow.ReversalPocPositionType.Anywhere, 0, 3, 1);
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Condition set 1
            if (gof.Delta[0] >= MinAbsDelta)
            {
                EnterLong(DefaultQuantity, "");
            }

            // Condition set 2
            if (gof.Delta[0] <= -MinAbsDelta)
            {
                EnterShort(DefaultQuantity, "");
            }
        }

        #region Properties
        [Description("")]
        [GridCategory("Parameters")]
        public int MinAbsDelta
        {
            get { return minAbsDelta; }
            set { minAbsDelta = Math.Max(1, value); }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int Target
        {
            get { return target; }
            set { target = Math.Max(1, value); }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int Stop
        {
            get { return stop; }
            set { stop = Math.Max(1, value); }
        }
        #endregion
    }
}
